class KCommandsSpeakCommand {
    constructor(options = {}) {
        if(!options.voice) throw new TypeError("No voice specify")
        if(!options.string) throw new TypeError("No message specify")
        if(!options.language) throw new TypeError("No language specify")
        if(!options.slow) throw new TypeError("No slow mode specify")
        if(typeof(options.slow) !== Boolean) throw new TypeError("Type of slow mode should be boolean")
        if(!options.timeout) throw new TypeError("No timeout specify")
        this.voice = options.voice
        this.string = options.string
        this.lang = options.language
        this.slow = options.slow
        this.timeout = options.timeout
    }
    run() {
        const audioUrl = await getAudioUrl(this.string, {
            lang: this.language,
            slow: this.slow,
            host:'https://translate.google.com',
            timeout: this.timeout,
        })
        try {
            this.voice.join().then(connection => {
              const dispatcher = connection.play(audioUrl)
              dispatcher.on('finish', () => {
                this.voice.leave()
              })
            })     
        } catch(e) {
            throw new TypeError("Something went wrong")
            console.log(e)
        }
    }
}

module.exports = {
    KCommandsSpeakCommand,
};